;##################################################################
; DIALOG AS MAIN
;##################################################################

#include "AutoDock.Inc"

#include "\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

.CONST
	TOPMSG				equ		2048
	IDD_DLG1			equ		1000
	IDD_DLG2			equ		2000

.DATA
	MsgTable			DD		TOPMSG DUP (?)
	icc	 				DQ		3FFF00000008h

	hInstance			DD 		?
	hDlg				DD		?
	hSubDlg				DD		?
	IsDocked			DD		?

	ClassName			DB		"DialogClass",0

.CODE

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControlsEx,OFFSET icc
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke ExitProcess,0

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:D

	; Define our main window class and register it
	mov D[wc.cbSize], SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov D[wc.lpfnWndProc], OFFSET MainDlgProc
	mov D[wc.cbClsExtra], NULL
	mov D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov eax, [hInstance]
	mov D[wc.hInstance], eax
	mov D[wc.hbrBackground], COLOR_BTNFACE + 1
	mov D[wc.lpszMenuName], NULL
	mov D[wc.lpszClassName], OFFSET ClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov D[wc.hIcon], eax
	mov D[wc.hIconSm], eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov D[wc.hCursor], eax

	invoke	RegisterClassEx, addr wc
	or eax,eax
	jnz >
		; If we were unable to register the class shut down
		invoke	ExitProcess, -1
	:

	invoke	CreateDialogParam, [hInstance],IDD_DLG1, NULL, NULL, NULL
	or eax,eax
	jnz >
		; If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],eax

	mov D[wc.lpfnWndProc],OFFSET SubDlgProc
	mov D[wc.lpszMenuName],NULL
	push "SubDialogClass"
	pop [wc.lpszClassName]
	invoke	RegisterClassEx, addr wc
	invoke	CreateDialogParam, [hInstance],IDD_DLG2,[hDlg], NULL, NULL
	or eax,eax
	jnz >
		; If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hSubDlg],eax

	invoke ShowWindow,[hDlg],[nCmdShow]

	:
		invoke GetMessage, ADDR msg,NULL,0,0
		or eax,eax
		jz >
			invoke IsDialogMessage, [hDlg], ADDR msg
			or eax,eax
			jnz <
				invoke TranslateMessage, ADDR msg
				invoke DispatchMessage, ADDR msg
				jmp <
	:

	mov eax,[msg.wParam]

	ret
ENDF

MainDlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_DESTROY
		jmp >>.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor eax,eax
	ret

ENDF

SubDlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL prect		:RECT

	cmp D[uMsg],WM_CREATE
	jne >.WM_GETMINMAXINFO
		
		jmp >>.EXIT

	.WM_GETMINMAXINFO
	cmp D[uMsg],WM_GETMINMAXINFO
	jne >.WM_COMMAND
		mov edi,[lParam]
		mov D[edi+MINMAXINFO.ptMinTrackSize.x],300
		mov D[edi+MINMAXINFO.ptMinTrackSize.y],200
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_WINDOWPOSCHANGING
		jmp >>.EXIT

	.WM_WINDOWPOSCHANGING
	cmp D[uMsg],WM_WINDOWPOSCHANGING
	jne >>.DEFPROC
		invoke GetWindowRect,[hDlg],OFFSET prect
		mov edi,[lParam]
		
		; Compare the tops to see if they are close enough
		mov eax,[edi+WINDOWPOS.y]
		sub eax,[prect.top]
		jns >
			neg eax
		:
		cmp eax,10
		jg >>.EXIT
		
		mov ecx,[prect.right]
		sub ecx,[edi+WINDOWPOS.x]
		jns >
			neg ecx
		:
		; will it be within 10 pixels of the parent right
		cmp ecx,10
		jg >
			; Dock the window
			mov eax,[prect.right]
			mov [edi+WINDOWPOS.x],eax
			mov eax,[prect.top]
			mov [edi+WINDOWPOS.y],eax
			jmp >.EXIT
		:
		mov eax,[edi+WINDOWPOS.x]
		add eax,[edi+WINDOWPOS.lx]
		mov ecx,[prect.left]
		sub ecx,eax
		jns >
			neg ecx
		:
		cmp ecx,10
		jg >
			; Dock the window
			mov eax,[prect.left]
			sub eax,[edi+WINDOWPOS.lx]
			mov [edi+WINDOWPOS.x],eax
			mov eax,[prect.top]
			mov [edi+WINDOWPOS.y],eax
			jmp >.EXIT
		:
		jmp >.EXIT

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor eax,eax
	ret

ENDF

